]> git.proxmox.com Git - mirror_ubuntu-bionic-kernel.git/blame - scripts/link-vmlinux.sh
x86/msr-index: Cleanup bit defines
[mirror_ubuntu-bionic-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
3a166fc2
NP
7# $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.o files
8# from top-level directories in the kernel tree, others are specified in
9# arch/$(ARCH)/Makefile. Ordering when linking is important, and
10# $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
11# which are linked conditionally (not within --whole-archive), and do not
12# require symbol indexes added.
1f2bfbd0
SR
13#
14# vmlinux
15# ^
16# |
17# +-< $(KBUILD_VMLINUX_INIT)
18# | +--< init/version.o + more
19# |
20# +--< $(KBUILD_VMLINUX_MAIN)
21# | +--< drivers/built-in.o mm/built-in.o + more
22# |
3a166fc2
NP
23# +--< $(KBUILD_VMLINUX_LIBS)
24# | +--< lib/lib.a + more
25# |
1f2bfbd0
SR
26# +-< ${kallsymso} (see description in KALLSYMS section)
27#
28# vmlinux version (uname -v) cannot be updated during normal
29# descending-into-subdirs phase since we do not yet know if we need to
30# update vmlinux.
31# Therefore this step is delayed until just before final link of vmlinux.
32#
33# System.map is generated to document addresses of all kernel symbols
34
35# Error out on error
36set -e
37
38# Nice output in kbuild format
39# Will be supressed by "make -s"
40info()
41{
42 if [ "${quiet}" != "silent_" ]; then
43 printf " %-7s %s\n" ${1} ${2}
44 fi
45}
46
3a166fc2
NP
47# Thin archive build here makes a final archive with symbol table and indexes
48# from vmlinux objects INIT and MAIN, which can be used as input to linker.
49# KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
50# added.
a5967db9
SR
51#
52# Traditional incremental style of link does not require this step
53#
54# built-in.o output file
55#
56archive_builtin()
57{
58 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
59 info AR built-in.o
60 rm -f built-in.o;
9a6cfca4 61 ${AR} rcsTP${KBUILD_ARFLAGS} built-in.o \
a5967db9
SR
62 ${KBUILD_VMLINUX_INIT} \
63 ${KBUILD_VMLINUX_MAIN}
64 fi
65}
66
1f2bfbd0
SR
67# Link of vmlinux.o used for section mismatch analysis
68# ${1} output file
69modpost_link()
70{
a5967db9
SR
71 local objects
72
73 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
3a166fc2
NP
74 objects="--whole-archive \
75 built-in.o \
76 --no-whole-archive \
77 --start-group \
78 ${KBUILD_VMLINUX_LIBS} \
79 --end-group"
a5967db9
SR
80 else
81 objects="${KBUILD_VMLINUX_INIT} \
82 --start-group \
83 ${KBUILD_VMLINUX_MAIN} \
3a166fc2 84 ${KBUILD_VMLINUX_LIBS} \
a5967db9
SR
85 --end-group"
86 fi
87 ${LD} ${LDFLAGS} -r -o ${1} ${objects}
1f2bfbd0
SR
88}
89
90# Link of vmlinux
91# ${1} - optional extra .o files
92# ${2} - output file
93vmlinux_link()
94{
95 local lds="${objtree}/${KBUILD_LDS}"
a5967db9 96 local objects
1f2bfbd0
SR
97
98 if [ "${SRCARCH}" != "um" ]; then
a5967db9 99 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
3a166fc2
NP
100 objects="--whole-archive \
101 built-in.o \
102 --no-whole-archive \
103 --start-group \
104 ${KBUILD_VMLINUX_LIBS} \
105 --end-group \
106 ${1}"
a5967db9
SR
107 else
108 objects="${KBUILD_VMLINUX_INIT} \
109 --start-group \
110 ${KBUILD_VMLINUX_MAIN} \
3a166fc2 111 ${KBUILD_VMLINUX_LIBS} \
a5967db9
SR
112 --end-group \
113 ${1}"
114 fi
115
116 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
117 -T ${lds} ${objects}
1f2bfbd0 118 else
a5967db9 119 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
3a166fc2
NP
120 objects="-Wl,--whole-archive \
121 built-in.o \
122 -Wl,--no-whole-archive \
123 -Wl,--start-group \
124 ${KBUILD_VMLINUX_LIBS} \
125 -Wl,--end-group \
126 ${1}"
a5967db9
SR
127 else
128 objects="${KBUILD_VMLINUX_INIT} \
129 -Wl,--start-group \
130 ${KBUILD_VMLINUX_MAIN} \
3a166fc2 131 ${KBUILD_VMLINUX_LIBS} \
a5967db9
SR
132 -Wl,--end-group \
133 ${1}"
134 fi
135
136 ${CC} ${CFLAGS_vmlinux} -o ${2} \
137 -Wl,-T,${lds} \
138 ${objects} \
139 -lutil -lrt -lpthread
1f2bfbd0
SR
140 rm -f linux
141 fi
142}
143
144
145# Create ${2} .o file with all symbols from the ${1} object file
146kallsyms()
147{
148 info KSYM ${2}
149 local kallsymopt;
150
b92021b0
RR
151 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
152 kallsymopt="${kallsymopt} --symbol-prefix=_"
6895f97e
JH
153 fi
154
1f2bfbd0 155 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 156 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
157 fi
158
4d5d5664 159 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
160 kallsymopt="${kallsymopt} --absolute-percpu"
161 fi
162
2213e9a6
AB
163 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
164 kallsymopt="${kallsymopt} --base-relative"
165 fi
166
00e6c28c
SR
167 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
168 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 169
a0439342
AB
170 local afile="`basename ${2} .o`.S"
171
172 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
173 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
174}
175
176# Create map file with all symbols from ${1}
177# See mksymap for additional details
178mksysmap()
179{
180 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
181}
182
1347a2ce
LT
183sortextable()
184{
185 ${objtree}/scripts/sortextable ${1}
186}
187
1f2bfbd0 188# Delete output files in case of error
1f2bfbd0
SR
189cleanup()
190{
1f2bfbd0
SR
191 rm -f .tmp_System.map
192 rm -f .tmp_kallsyms*
1f2bfbd0 193 rm -f .tmp_vmlinux*
a5967db9 194 rm -f built-in.o
1f2bfbd0
SR
195 rm -f System.map
196 rm -f vmlinux
197 rm -f vmlinux.o
198}
199
ab160dbb
SB
200on_exit()
201{
202 if [ $? -ne 0 ]; then
203 cleanup
204 fi
205}
206trap on_exit EXIT
207
208on_signals()
209{
210 exit 1
211}
212trap on_signals HUP INT QUIT TERM
213
1f2bfbd0
SR
214#
215#
216# Use "make V=1" to debug this script
217case "${KBUILD_VERBOSE}" in
218*1*)
219 set -x
220 ;;
221esac
222
223if [ "$1" = "clean" ]; then
224 cleanup
225 exit 0
226fi
227
228# We need access to CONFIG_ symbols
423a8155
MM
229case "${KCONFIG_CONFIG}" in
230*/*)
231 . "${KCONFIG_CONFIG}"
232 ;;
233*)
234 # Force using a file from the current directory
235 . "./${KCONFIG_CONFIG}"
236esac
1f2bfbd0 237
1f2bfbd0
SR
238# Update version
239info GEN .version
278ae604
MY
240if [ -r .version ]; then
241 VERSION=$(expr 0$(cat .version) + 1)
242 echo $VERSION > .version
1f2bfbd0 243else
278ae604
MY
244 rm -f .version
245 echo 1 > .version
1f2bfbd0
SR
246fi;
247
248# final build of init/
6b90bd4b 249${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
1f2bfbd0 250
abac4c89
NP
251archive_builtin
252
253#link vmlinux.o
254info LD vmlinux.o
255modpost_link vmlinux.o
256
257# modpost vmlinux.o to check for section mismatches
258${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
259
1f2bfbd0
SR
260kallsymso=""
261kallsyms_vmlinux=""
262if [ -n "${CONFIG_KALLSYMS}" ]; then
263
264 # kallsyms support
265 # Generate section listing all symbols and add it into vmlinux
266 # It's a three step process:
267 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
268 # but __kallsyms is empty.
269 # Running kallsyms on that gives us .tmp_kallsyms1.o with
270 # the right size
271 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
272 # the right size, but due to the added section, some
273 # addresses have shifted.
274 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
275 # 3) That link may have expanded the kernel image enough that
276 # more linker branch stubs / trampolines had to be added, which
277 # introduces new names, which further expands kallsyms. Do another
278 # pass if that is the case. In theory it's possible this results
279 # in even more stubs, but unlikely.
280 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
281 # other bugs.
282 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
283 #
284 # a) Verify that the System.map from vmlinux matches the map from
285 # ${kallsymso}.
286
287 kallsymso=.tmp_kallsyms2.o
288 kallsyms_vmlinux=.tmp_vmlinux2
289
290 # step 1
291 vmlinux_link "" .tmp_vmlinux1
292 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
293
294 # step 2
295 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
296 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
297
7e2b37c9
NP
298 # step 3
299 size1=$(stat -c "%s" .tmp_kallsyms1.o)
300 size2=$(stat -c "%s" .tmp_kallsyms2.o)
301
302 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
1f2bfbd0
SR
303 kallsymso=.tmp_kallsyms3.o
304 kallsyms_vmlinux=.tmp_vmlinux3
305
306 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
307
308 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
309 fi
310fi
311
312info LD vmlinux
313vmlinux_link "${kallsymso}" vmlinux
314
1347a2ce
LT
315if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
316 info SORTEX vmlinux
317 sortextable vmlinux
318fi
319
1f2bfbd0
SR
320info SYSMAP System.map
321mksysmap vmlinux System.map
322
323# step a (see comment above)
324if [ -n "${CONFIG_KALLSYMS}" ]; then
325 mksysmap ${kallsyms_vmlinux} .tmp_System.map
326
327 if ! cmp -s System.map .tmp_System.map; then
5369f550 328 echo >&2 Inconsistent kallsyms data
367e43c5 329 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
330 exit 1
331 fi
332fi